TEMPLATE = lib
CONFIG += plugin
QT += gui
QT += serialport


INCLUDEPATH+=$$_PRO_FILE_PWD_
INCLUDEPATH+=$$_PRO_FILE_PWD_/support
INCLUDEPATH+=$$_PRO_FILE_PWD_/plugins
INCLUDEPATH+=$$_PRO_FILE_PWD_/include
INCLUDEPATH+=$$_PRO_FILE_PWD_/HMI
INCLUDEPATH+=$$_PRO_FILE_PWD_/HMI/screens
INCLUDEPATH+=$$_PRO_FILE_PWD_/HMI/support
INCLUDEPATH+=$$_PRO_FILE_PWD_/src
INCLUDEPATH+=$$_PRO_FILE_PWD_/src/ATBAPP
INCLUDEPATH+=$$_PRO_FILE_PWD_/src/ATBAPP/support
INCLUDEPATH+=$$_PRO_FILE_PWD_/src/ATBAPP/support/VMC

QMAKE_CXXFLAGS += -Wno-deprecated-copy -O

# default
ARCH = PTU5

DEFINES+=ATB_QT_VERSION=\\\"5.11\\\"

contains( CONFIG, DesktopLinux ) {
    QMAKE_CC = ccache $$QMAKE_CC
    QMAKE_CXX = ccache $$QMAKE_CXX
    QMAKE_CXXFLAGS += -std=c++11
    # QMAKE_CXXFLAGS += -Wno-deprecated-ctor
    linux-clang {  QMAKE_CXXFLAGS += -Qunused-arguments   }
    ARCH = DesktopLinux
}

contains( CONFIG, PTU5 ) {
    # QMAKE_CC = ccache $$QMAKE_CC
    # QMAKE_CXX = ccache $$QMAKE_CXX
    QMAKE_CXXFLAGS += -std=c++11
    linux-clang {  QMAKE_CXXFLAGS += -Qunused-arguments   }
    CONFIG += link_pkgconfig
    ARCH = PTU5
}

contains( CONFIG, PTU5_YOCTO ) {
    greaterThan(QT_MAJOR_VERSION, 4): QT += serialport
    PTU5BASEPATH = /opt/devel/ptu5
    ARCH = PTU5

    # add qmqtt lib
    #LIBS += -lQt5Qmqtt
}

TARGET   = ATBVMCPlugin
#DESTDIR  = ../plugins
INTERFACE = VMCInterface
INTERFACE_DEFINITION = $${PWD}/src/ATBAPP/VMCInterface.h

DEFINES += VMCPLUGIN_LIBRARY

# Default rules for deployment.
#qnx: target.path = /tmp/$${TARGET}/bin
#else: unix:!android: target.path = /opt/$${TARGET}/bin
#!isEmpty(target.path): INSTALLS += target

# ATBAPP interface
HEADERS += \
    AppControl.h \
    ATBHMIconfig.h \
    atb_system.h \
    include/interfaces.h \
    src/ATBAPP/VMCInterface.h \
    src/ATBAPP/ATBVMCPlugin.h \
    src/ATBAPP/UnifiedDCVMCInterface.h \
    src/ATBAPP/support/VMC/com_interface.h \
    src/ATBAPP/support/VMC/ReceiveBuffer.h \
    src/ATBAPP/support/VMC/SendBuffer.h \
    src/ATBAPP/support/VMC/vmc.h \
    src/ATBAPP/support/VendingData.h

SOURCES += \
    atb_system.cpp \
    AppControl.cpp \
    ATBHMIconfig.cpp \
    src/ATBAPP/ATBVMCPlugin.cpp \
    src/ATBAPP/support/VMC/com_interface.cpp \
    src/ATBAPP/support/VMC/ReceiveBuffer.cpp \
    src/ATBAPP/support/VMC/SendBuffer.cpp \
    src/ATBAPP/support/VMC/vmc.cpp \
    src/ATBAPP/support/VendingData.cpp

DISTFILES += \
    generate-version.sh


# Define how to create version.h
VERSION_H = $$PWD/include/version.h
version.output = $$PWD/include/version.h
version.commands = $$PWD/generate-version.sh $${ARCH} $${TARGET} $${INTERFACE} $${INTERFACE_DEFINITION} $${VERSION_H}
version.depends = FORCE
version.input = VERSION_H
version.variable_out = HEADERS
QMAKE_EXTRA_COMPILERS += version
QMAKE_CLEAN += $${PWD}/include/version.h
