#ifndef VMCINTERFACE_H
#define VMCINTERFACE_H

#include <QtPlugin>

#include <QSettings>
#include <QString>

#include "ATBHMIconfig.h"
#include "ATBAPPplugin.h"
#include "UnifiedDCVMCInterface.h"

namespace nsVMCInterface {
    using PLUGIN_STATE = UnifiedDCVMCInterface::PLUGIN_STATE;
    using RESULT_STATE = UnifiedDCVMCInterface::RESULT_STATE;
    using CASH_STATE = UnifiedDCVMCInterface::CASH_STATE;
    using TICKET_VARIANT = UnifiedDCVMCInterface::TICKET_VARIANT;
}


class ATBHMIconfig;

class VMCInterface : public UnifiedDCVMCInterface {

    Q_OBJECT
    Q_INTERFACES(ATBAPPplugin)
    Q_INTERFACES(UnifiedDCVMCInterface)

public:

    explicit VMCInterface(QObject *parent = nullptr)
        : UnifiedDCVMCInterface(parent) {}

    virtual PLUGIN_STATE initPlugin(QObject *eventReceiver, QSettings const &settings) override {
        return initVMCPlugin(eventReceiver, settings);
    }

    virtual PLUGIN_STATE initPlugin(QObject *eventReceiver, ATBHMIconfig *config) override {
        return initVMCPlugin(eventReceiver, config->getSettings());
    }

    virtual ~VMCInterface() {}

    /**
     * @brief initDCPlugin
     * @param eventReceiver - QObject to receive ATBMachineEvents or HealthEvents
     * @param settings
     * @return
     */
    virtual PLUGIN_STATE initVMCPlugin(QObject *eventReceiver, const QSettings & settings) = 0;
};

#endif // VMCINTERFACE_H
