#ifndef COM_INTERFACE_H
#define COM_INTERFACE_H

#include <QObject>

#if QT_VERSION >=0x050000
class QSerialPort;
#else
class QextSerialPort;
#endif


class COM_interface : public QObject
{
    Q_OBJECT

private:
#if QT_VERSION >=0x050000
    QSerialPort *port;
#else
    QextSerialPort *port;
#endif
    QByteArray *buffer;


public:
    explicit COM_interface(QObject *parent = nullptr);
    ~COM_interface();
    
    int open(const QString & portname, int baudrate);
    int open(const QString & portname, int baudrate, int dataBits, int stopBits, int parity);
    int close(void);

    void putChar(const char c);

    int isOpen(void);



signals:
    void ReadData(QByteArray *buffer);
    void connected(void);
    void disconnected(void);

    
public slots:

private slots:
    void onReadyRead(void);
    void onDsrChanged(bool state);
};

#endif // COM_INTERFACE_H
